// $Id: test-env-0.C,v 1.2 2002/10/20 13:09:42 dvermeir Exp $ 
#include "env.h"

using namespace std;
using namespace Dv;
using namespace Util;

int
main(int, char**) {

try {

  // 1. simple MBox test.
  {
  const string value("DV");
  Env	e;
  e["dirk"]["vermeir"] 
  	= value;
  cout << "value = " << e["dirk"]["vermeir"] 
       << " (expected \"" << value << "\")"
       << endl;
  if (e("dirk")("vermeir") != value)
    return 1;
  }

  // 2. should give an error
  {
  Env	e;
  e["dirk"]["vermeir"] = "DV";
  bool ok(false);
  try {
    e[0]["abc"] = 1;
    }
  catch (Env::Exception& e) {
    cerr << "Expected: " << e.what() << endl;
    ok = true;
    }
  if (!ok) {
    cerr << "error: no exception where one was expected" << endl;
    return 1;
    }
  }

  // 3. array test
  {
  Env e;
  for (int i=0; i<10; ++i)
    e["a"][i] = i;
  cerr << "checking.." << endl;
  for (int i=0; i<10; ++i) 
    if (e("a")(i) != i) {
      cerr << "e(\"a\")(" << i << ") = " << e("a")(i) 
           << " (expected " << i << ")"
	   << endl;
      return 1;
      }
  }

  }
catch (exception& e) {
  cerr << e.what() << endl;
  return 1;
  }
return 0;
}
