// $Id: test-env-1.C,v 1.2 2002/10/20 13:09:42 dvermeir Exp $
#include <iostream>
#include "env.h"

using namespace std;
using namespace Dv;
using namespace Util;

int
main(int, char**) {

try {
  Env e;

  cerr << "1. check whether undefined test works." << endl;

  if (!e("dirk")("vermeir").defined())
    cerr << "e(dirk)(vermeir) undefined" << endl;
  else
    throw runtime_error("e(dirk)(vermeir) defined but shouldn't");

  if (!e(1)("vermeir").defined())
    cerr << "e(1)(vermeir) undefined" << endl;
  else
    throw runtime_error("e(1)(vermeir) defined but shouldn't");

  cerr << "2. check whether it is impossible to assign to nil" << endl;

  {
  bool ok(true);
  try {
    // Even when const_casting, this should not succeed.
    // around the operator() restrictions.
    const_cast<Env&>(e("dirk")) = "abc";
    cerr << e("dirk") << ": should have failed" << endl;
    ok = false;
    }
  catch (exception& e) {
    }
  }

  cerr << "3. check whether undefined test works on deeper levels." << endl;
  e["dirk"] = "abc";

  if (!e("dirk")("vermeir").defined())
    cerr << "e(dirk)(vermeir) undefined" << endl;
  else
    throw runtime_error("e(dirk)(vermeir) defined but shouldn't");

  cerr << "4. check whether defined test works." << endl;
  if (!e("dirk").defined())
    throw runtime_error("e(dirk) not defined but should");
  else
    cerr << "e(dirk) defined = " << e("dirk") << endl;

  cerr << "4. check whether is_array test works." << endl;
  e["fred"][1] = "1";

  if (e("fred").is_array())
    cerr << "e(fred) is array" << endl;
  else
    throw runtime_error("e(fred) not an array but should");

  if (e("fred").is_map())
    throw runtime_error("e(fred) is a map but shouldn't");
  else
    cerr << "e(fred) is not a map" << endl;

  if (e("fred").is_string())
    throw runtime_error("e(fred) is a string but shouldn't");
  else
    cerr << "e(fred) is not a string" << endl;

  cerr << "done" << endl;
  }
catch (exception& e) {
  cerr << e.what() << endl;
  return 1;
  }
return 0;
}
